// version de développement / ébauche
// sous lience CERN OHL
// Projet petites éoliennes Pliboo

echo(version=version());

ECART = 0.4; // application d'un écart 
LONG_EQ = 40; // longueur de l'équerre support
LARG_FENTE = 8; // largeur 
INTERJANTE = 28; // espace interne entre les paroies de la jantes
EP_COUVERCLE = 1; // épaisseur du couvercle

L1=40;    // longueur heu d'la barre
VIS=20;      // H centre de la vis support
Ep_socle=2;       // Épaisseur du socle du manche
Ep_socleBords = Ep_socle + 5; // Épaisseur des bords du socle manche 
Ep_bague_1 = 3; // Épaisseur de la bague de fixation num 1
Ep_bague_2 = Ep_bague_1; // Épaisseur de la bague de fixation num 2
Ep_bague_sup_1 = Ep_bague_1; // Épaisseur du support d'impression 3d de la bague pour la machoire 1
Ep_bague_sup_2 = 2* Ep_bague_1; // Épaisseur du support d'impression 3d de la bague pour la machoire 2
Ep_machoire_bord = INTERJANTE - 10; // épaisseur des paroies de la cage à bobine
Ep_couvercle = 1; // épaisseur du couvercle
H_bague_1 = Ep_socle; // position en Z de la bague 1
H_bague_2 = Ep_socle + H_bague_1 + ECART; // position en Z de la bague 2
H_couvercle_dessous = 0;
H_couvercle_dessus = Ep_machoire_bord - Ep_couvercle;

EP_2=EP_1 + 5;  // 
EP_3= 3;  // Épaisseur de la fixation de l'écrou
EP_4 = EP_3 + EP_1; // Épaisseur du socle du manche n°2
EP_5 = EP_4 + EP_3; // Épaisseur de la surcouche support
EP_6 = 10; // Épaisseur du fixateur
L_4_1=23; // Longueur du petit côté du C
L_4_2=46; // Longueur du grand côté du C
L_M = 53; // Longueur du manche


// VUES POUR L'IMPRESSIONS
// -------------------
// PIECE NUM 1
 impres_piece_1();
// PIECE NUM 2
// impres_piece_2();


// VUES DES PIECES
// -----------------------------
//vue_1(); // Assemblée
//vue_2(); // Éclatée
//vue_3(); // piece 1
//vue_4(); // piece 2
//vue_0(); // piece sans la bague



// MODULES
// -------------------

// SOCLE DU MANCHE
// Part 1
module part_1(X) {
color("violet" , 0.5)
    rotate([0,0,0])
        translate([0, 0, 0])
           rotate([0,0,0])
              linear_extrude(height = X, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-05-brasSocle");
}

// BORDS DU MANCHE
// Part 2
module part_2(X) {
color("yellow" , 0.5)
    rotate([0,0,0])
        translate([0, 0, 0])
           rotate([0,0,0])
              linear_extrude(height = X, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-04-brasBord");
}

// MACHOIRE 1: BAGUE DE FIXATION DU MANCHE
// Part 3
module part_3(Haut,Epais) {
color("grey" , 0.5)
    rotate([0,0,0])
        translate([0, 0, Haut])
           rotate([0,0,0])
              linear_extrude(height = Epais, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-03-bagueFixation");
}

// MACHOIRE 1: SUPPORT D'IMPRESSION DE LA BAGUE 
// Part 4
module part_4(Haut,Epais) {
color("blue" , 0.5)
    rotate([0,0,0])
        translate([0, 0, Haut])
           rotate([0,0,0])
              linear_extrude(height = Epais, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-06-bagueSupport-I3D");
}

// BORD DE MACHOIRE 
// Part 5
module part_5(Epais) {
color("red" , 0.5)
    rotate([0,0,0])
        translate([0, 0, 0])
           rotate([0,0,0])
              linear_extrude(height = Epais, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-01-cageBords");
}

// DESSUS ET DESSOUS DE MACHOIRE 
// Dessus - Part 6_1
module part_6_1(Haut,Epais) {
color("red" , 0.5)
    rotate([0,0,0])
        translate([0, 0, Haut])
           rotate([0,0,0])
              linear_extrude(height = Epais, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-02-cageCouvercle");
}

// Dessous - Part 6_2
module part_6_2(Haut,Epais) {
color("red" , 0.5)
    rotate([0,0,0])
        translate([0, 0, Haut])
           rotate([0,0,0])
              linear_extrude(height = Epais, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-02-cageCouvercle");
}

// BORNIER
// Part 7
module part_7 (H,L) {
color("orange" , 0.5)
            translate([45, 10, H])
    rotate([0,90,0])
        translate([0, 0, 0])
           rotate([0,0,0])
              cylinder(h = L, r1 = 2, r2 = 2, center = false);
}

// Dessous - Part 8
module part_8(Haut,Epais) {
color("red" , 0.5)
    rotate([0,0,0])
        translate([0, 0, Haut])
           rotate([0,0,0])
              linear_extrude(height = Epais, center = false, convexity = 10)
                  import(file = "porteBobProfilAlu-30mm-V19-03-01-00.dxf", layer = "02-07-bagueExcav");
}



// PARTIES COMMUNES AUX DEUX MACHOIRES
// Assemblage 0
module assemblage_0() {
    difference() {
        union() {
            part_1(Ep_socle);
            part_2(Ep_socleBords);
            part_5(Ep_machoire_bord);
            part_6_1(H_couvercle_dessous, Ep_couvercle);
            part_6_2(H_couvercle_dessus, Ep_couvercle);
            }
        }
    }

// Assemblage 1
module assemblage_1() {
    difference(){
        union(){
            assemblage_0();
            part_3(H_bague_1, Ep_bague_1);
            part_4(H_bague_1, Ep_bague_sup_1);
            }
        part_7(10,30);
        }
}



// Assemblage 2
module assemblage_2() {
    difference(){
        union(){
            assemblage_0();
            part_3(H_bague_2+ECART, Ep_bague_2+ECART);
            part_4(H_bague_1, Ep_bague_sup_2+ECART);
            }
        part_7(10,30);
        part_8(H_bague_1, Ep_bague_1+ECART);
        }
}

// VUES
// -------

// VUE ASSEMBLÉE
module vue_1() {
    color("grey", 0.5) assemblage_1(); // machoire 1
    color ("red", 0.5) mirror([0,1,0]) assemblage_2(); // machoire 2
}

// VUE ÉCLATÉE
module vue_2() {
    color("grey", 0.5) translate([0,10,-5])assemblage_1(); // machoire 1
    color ("red", 0.5) translate([0,-10,5]) mirror([0,1,0]) assemblage_2(); // machoire 2
}

// VUE PIECE ZERO
module vue_0() {
    assemblage_0(); // machoire sans la bague
}


// VUE PIECE 1
module vue_3() {
    assemblage_1(); // machoire 1
}

// VUE PIECE 2
module vue_4() {
    mirror([0,1,0]) assemblage_2(); // machoire 2
}

// VUE IMPRESSION PIECE 1
module impres_piece_1() {
    rotate([-90,0,0]) vue_3(); // pièce 1 retournée sur le côté
    }

// VUE IMPRESSION PIECE 2
module impres_piece_2() {
    rotate([90,0,0]) vue_4(); // pièce 2 retournée sur le côté
    }


/*
CubePoints = [
  [  0,  0,  0 ],  //0
  [ 10,  0,  0 ],  //1
  [ 10,  7,  0 ],  //2
  [  0,  7,  0 ],  //3
  [  0,  0,  5 ],  //4
  [ 10,  0,  5 ],  //5
  [ 10,  7,  5 ],  //6
  [  0,  7,  5 ]]; //7
  
CubeFaces = [
  [0,1,2,3],  // bottom
  [4,5,1,0],  // front
  [7,6,5,4],  // top
  [5,6,2,1],  // right
  [6,7,3,2],  // back
  [7,4,0,3]]; // left
  
SocleManche = [
[0,0],
[4,0],
[4,4.5],
[37,4.5],
[37,0],
[53,0],
[53,23],
[0,23]
];

scale([1,0.5,1]) color("green") linear_extrude(height = 10, center = false, convexity = 10) polygon(SocleManche);

// polyhedron( CubePoints, CubeFaces );
// polyhedron( CubePoints );
*/
